package com.xx.merchanthbh.data.http.requst;

import com.xx.merchanthbh.data.http.BaseRespons;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;

import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class HuanBoHaiRequest extends BaseRespons {


    /**
     * 活动列表
     */
    public Observable<BaseResponse<List<ActivityCenterBean>>> getActivityList() {

        ApiParams<HuanBoHaiRequestBody> apiParams = new ApiParams<HuanBoHaiRequestBody>();
        HuanBoHaiRequestBody requestBody = new HuanBoHaiRequestBody("1", "3");
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().getActivityList(body);
    }

    /**
     * 获取广告列表
     * @param companyId 所属公司ID
     * @return
     */
    public Observable<BaseResponse<List<AdvertisingBean>>> getAdList(String companyId) {

        ApiParams<AdvertisingBean> apiParams = new ApiParams<AdvertisingBean>();
        AdvertisingBean requestBody = new AdvertisingBean(companyId,null,null,null,null,"2");
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().postADList(body);
    }


    /**
     * 资讯列表
     */
    public Observable<BaseResponse<List<ConsultationInformationBean>>> getConsultationInformationList() {

        ApiParams<ConsultationRequestBody> apiParams = new ApiParams<ConsultationRequestBody>();
        ConsultationRequestBody requestBody = new ConsultationRequestBody("2");
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().getConsultationInformationList(body);
    }
    /**
     * "activityShop": 传店铺类型 1-河西 2-滨海
     * "isPublish": 传APP类型 1-消费者 2-企业 3-商户
     */
    public class HuanBoHaiRequestBody {
        public String activityShop;
        public String isPublish;


        public HuanBoHaiRequestBody(String activityShop, String isPublish) {
            this.activityShop = activityShop;
            this.isPublish = isPublish;
        }
    }
    /**
     * "isPublish": 传APP类型 1-消费者 2-企业 3-商户
     */
    public class ConsultationRequestBody {
        public String appSide;

        public ConsultationRequestBody(String appSide) {
            this.appSide = appSide;
        }
    }
}
