package com.xx.merchanthbh.data.http.requst;


import com.xx.merchanthbh.data.http.BaseRespons;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.JobInformationBean;

import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

/*人才招聘列表*/
public class RecruitmentRequest extends BaseRespons {

    /**
     * 招聘列表
     */
    public Observable<BasePageResponse<JobInformationBean>> getJobInformationList(String recruitmentType)
    {
        ApiParams<JobRequestBody> apiParams = new ApiParams<JobRequestBody>();
        JobRequestBody requestBody = new JobRequestBody(recruitmentType,"1","10");
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().getJobInformationList(body);
    }
    /**
     * 获取广告列表
     * affiliatedCompany  string 所属公司 1- 河西 2-滨海
     * rotographDisplay string  1-消费者app 2-商户app 3-企业app
     */
    public Observable<BaseResponse<List<AdvertisingBean>>> getAdList() {
        ApiParams<AdvertisingRequestBody> apiParams = new ApiParams<AdvertisingRequestBody>();
        AdvertisingRequestBody requestBody = new AdvertisingRequestBody("1","2");
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().getADList(body);
    }

    /**
     * 不需要传参
     */
    public class JobRequestBody {
        public String recruitmentType;
        public String pageNum;
        public String pageSize;
        public JobRequestBody(String recruitmentType,String pageNum, String pageSize) {
            this.recruitmentType = recruitmentType;
            this.pageNum = pageNum;
            this.pageSize = pageSize;
        }
    }
    /**
     * 获取广告列表
     * affiliatedCompany  string 所属公司 1- 河西 2-滨海
     * rotographDisplay string  1-消费者app 2-商户app 3-企业app
     */
    public class AdvertisingRequestBody {
        public String affiliatedCompany;
        public String rotographDisplay;

        public AdvertisingRequestBody(String affiliatedCompany,String rotographDisplay) {
            this.affiliatedCompany = affiliatedCompany;
            this.rotographDisplay = rotographDisplay;
        }
    }
}
