package com.xx.merchanthbh.ui.activities;

import android.os.Bundle;

import androidx.lifecycle.Observer;

import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.ActivitiesRequest;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.databinding.ActivityActivitiesListBinding;
import com.xx.merchanthbh.fragment.adapter.ActivitiesCenterListAdapter;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class ActivitiesActivity extends BaseActivity<ActivityActivitiesListBinding, ActivitiesViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_activities_list;
    }

    @Override
    public int initVariableId() {
        return BR.activitiesViewModel;
    }


    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        viewModel.getActivityCenterList();
        //展示活动列表
        ActivitiesCenterListAdapter adapter = new ActivitiesCenterListAdapter(this);

        binding.rvDblList.setAdapter(adapter);

        viewModel.ActivityCenterList.observe(this, new Observer<List<ActivityCenterBean>>() {
            @Override
            public void onChanged(List<ActivityCenterBean> activityCenterBeanList) {
                adapter.mList = activityCenterBeanList;
                adapter.notifyDataSetChanged();
            }
        });


    }
    @Override
    public ActivitiesViewModel initViewModel() {
        ActivitiesRequest lm = new ActivitiesRequest();
        return new ActivitiesViewModel(getApplication(), lm);
    }
}
