package com.xx.merchanthbh.ui.activities;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;


import com.xx.merchanthbh.data.http.requst.ActivitiesRequest;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class ActivitiesViewModel extends BaseViewModel<ActivitiesRequest> {
    //    创建活动中心实体对象
    public MutableLiveData<List<ActivityCenterBean>> ActivityCenterList = new MutableLiveData<>(new ArrayList<>());

    public ActivitiesViewModel(@NonNull Application application) {
        super(application);
    }

    public ActivitiesViewModel(@NonNull Application application, ActivitiesRequest model) {
        super(application, model);
    }
    //调用活动中心的接口信息
    public void getActivityCenterList() {
        model.getActivityList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ActivitiesViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<ActivityCenterBean>>() {
                    @Override
                    public void onSuccess(List<ActivityCenterBean> resultBean) {
                        ActivityCenterList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

}
