package com.xx.merchanthbh.ui.addproduct;

import android.app.Application;
import android.text.TextUtils;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.AddProductRequest;
import com.xx.merchanthbh.data.http.requst.body.ProductBody;
import com.xx.merchanthbh.data.http.respons.BoothBean;
import com.xx.merchanthbh.data.http.respons.CategoryBean;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.dialog.BoothListDialog;
import com.xx.merchanthbh.dialog.ProductTypeDialog;
import com.xx.merchanthbh.ui.addproduct.data.ProductTypeProvider;
import com.xx.merchanthbh.ui.addproduct.data.TextListProvider;
import com.xx.merchanthbh.ui.merchantenter.AddBrankViewModel;
import com.xx.xxviewlibrary.base.xxBaseDialog;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;
import com.xx.xxviewlibrary.utils.AddImgAdapter;
import com.xx.xxviewlibrary.witget.model.FileBean;

import java.io.File;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseModel;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.StringUtils;

public class AddProductViewModel extends BaseViewModel<AddProductRequest>  {

    public MutableLiveData<String> name;

    public MutableLiveData<Integer> brandGone=new MutableLiveData(View.GONE);

    /**
     * productAdapter 商品图片
     * detailAdapter 详细图片
     */
    public AddImgAdapter productAdapter,detailAdapter;

    public ProductTypeProvider categoryDialogData;

    public ObservableField<String> pNumber= new ObservableField<>("");

    public ObservableField<String> pName= new ObservableField<>("");

    public ObservableField<String> pDescribe= new ObservableField<>("");

    public ObservableField<String> pPrice= new ObservableField<>("");

    public ObservableField<String> pType= new ObservableField<>("");

    public String typeId="";

    public ObservableField<String> pBrand= new ObservableField<>("");

    public String brandID=null;

    public AddProductViewModel(@NonNull Application application) {
        super(application);
    }

    public AddProductViewModel(@NonNull Application application, AddProductRequest model) {
        super(application, model);
    }

    @Override
    public void onResume() {
        super.onResume();
        getCategoryData();
        if (model.getMerchantBean().getBrandAuthorizationList().size()<=0)
        {
            brandGone.setValue(View.GONE);
        }else {
            brandGone.setValue(View.VISIBLE);
        }
    }

    /**
     * 上传图片
     * @param type
     * @param position
     */
    public void openPhoto(AddImgAdapter type, int position)
    {



        int max=1;
        if (TextUtils.isEmpty(productAdapter.mList.get(position).getId()))
        {
            max=5- productAdapter.getItemCount()+1;
        }


        startPhotoPage(true, max, new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {
                List<File> fList=new ArrayList<>();
                for (Photo p:photos)
                {
                    fList.add(new File(p.path));
                }

                model.upLoadFiles(fList).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(AddProductViewModel.this)
                        .doOnSubscribe (new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {

                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {

                                if (TextUtils.isEmpty(type.mList.get(position).getId()))
                                {

                                    List<FileBean> fList=new ArrayList<>();
                                    for (Filebean fb:resultBean)
                                    {
                                        fList.add(new FileBean(fb.getBusinessId(), fb.getUrl()));
                                    }
                                    type.addImg(fList);
                                }else {
                                    type.mList.get(position).setId(resultBean.get(0).getBusinessId());
                                    type.mList.get(position).setPath(resultBean.get(0).getUrl());
                                }

                                type.notifyDataSetChanged();
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }


    /**
     * 获取分类数据
     */
    public void getCategoryData()
    {
        model.getCategory().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AddProductViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {

                    }
                }).subscribe(new ApiDisposableObserver<List<CategoryBean>>() {
                    @Override
                    public void onSuccess(List<CategoryBean> resultBean) {
                        categoryDialogData=new ProductTypeProvider(resultBean);
                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }

    /**
     * 添加商品
     * @param view
     */
    public void saveDrafts(View view)
    {
        List<CategoryBean> list=new ArrayList();
        String productImgss=StringUtils.join(list,",",(data) -> data.getCategoryName());

        /*if (productAdapter.mList.get(productAdapter.mList.size()-1).getId()==null)
        {
            productAdapter.mList.remove(productAdapter.mList.size()-1);
        }

        if (detailAdapter.mList.get(detailAdapter.mList.size()-1).getId()==null)
        {
            detailAdapter.mList.remove(detailAdapter.mList.size()-1);
        }*/

        String productImgs=StringUtils.join(productAdapter.mList,",",(data) -> data.getId()).replace(",null","").replace("null","");
        String describeImgs=StringUtils.join(detailAdapter.mList,",",(data) -> data.getId()).replace(",null","").replace("null","");

        String staticSttr;
        if (view.getId()==R.id.btn_aap_draft)
        {
            staticSttr="1";
        }else {
            staticSttr="2";
        }

        model.addProduct(pNumber.get(),pNumber.get(),productImgs,describeImgs,typeId,pPrice.get(),pDescribe.get(),brandID,staticSttr).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AddProductViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {

                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {
                    @Override
                    public void onSuccess(Boolean resultBean) {
                        finish();
                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }

    /**
     * 显示分类弹窗
     * @param view
     */
    public void showCategoryDialog(View view)
    {
        ProductTypeDialog dialog=new ProductTypeDialog(view.getContext(),categoryDialogData);
        dialog.setDialogClickListener(new xxBaseDialog.onDialogClickListener<ProductTypeDialog.ProductTypeCurrent>() {
            @Override
            public void dialogClickBack(int code, ProductTypeDialog.ProductTypeCurrent data) {
                typeId=data.getId();
                pType.set(data.getContext());
                dialog.dismiss();
            }
        });
        dialog.show();
    }
    public void openBrankDialog(View view)
    {
        BoothListDialog dialoh=new BoothListDialog(view.getContext(),model.getMerchantBean().getBrandAuthorizationList());
        dialoh.setDialogClickListener(new xxBaseDialog.onDialogClickListener<TextListProvider>() {
            @Override
            public void dialogClickBack(int code, TextListProvider data) {
                pBrand.set(data.providerText());
                brandID=data.ProviderId();
            }
        });

        dialoh.show();
    }






}
