package com.xx.merchanthbh.ui.appeallist

import android.app.ActionBar.LayoutParams
import android.content.Context
import android.graphics.Bitmap
import android.view.View
import android.widget.ImageView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.RoundedCorners
import com.bumptech.glide.request.RequestOptions
import com.bumptech.glide.request.target.Target
import com.xx.merchanthbh.R
import com.xx.merchanthbh.data.http.respons.AppealListBean
import com.xx.merchanthbh.databinding.ItemAppealListBinding
import com.xx.merchanthbh.utils.RetrofitClient
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter
import me.jessyan.autosize.utils.AutoSizeUtils

class AppealListAdapter(context:Context): xxBaseRecyclerViewAdapter<ItemAppealListBinding, AppealListBean>(context) {
    override fun initLayout(): Int {
        return R.layout.item_appeal_list
    }

    override fun covert(dataBind: ItemAppealListBinding?, data: AppealListBean?, position: Int) {
        dataBind?.data=data
        dataBind?.numTitle="诉求单号："

        when (data?.appealStatus)
        {
            "COMPLETED"->
            {
                dataBind?.tvIalStatic?.setText("已完成")
                dataBind?.tvIalStatic?.setTextColor(mContext.getColor(R.color.text_foreground))
                dataBind?.btnIalEdit?.visibility= View.GONE
            }
            "PROCESSING"->
            {
                dataBind?.tvIalStatic?.setText("处理中")
                dataBind?.tvIalStatic?.setTextColor(mContext.getColor(R.color.static_deal))
                dataBind?.btnIalEdit?.visibility= View.GONE
            }
            "TO_BE_ALLOT"->
            {
                dataBind?.tvIalStatic?.setText("待分配")
                dataBind?.tvIalStatic?.setTextColor(mContext.getColor(R.color.text_foreground))
                dataBind?.btnIalEdit?.visibility= View.GONE
            }
            "REJECTED"->
            {
                dataBind?.tvIalStatic?.setText("已驳回")
                dataBind?.tvIalStatic?.setTextColor(mContext.getColor(R.color.static_reject))
                dataBind?.btnIalEdit?.visibility= View.VISIBLE
            }
        }

        for (file in data?.appealFiles!!)
        {
            var iv=ImageView(mContext)
            var lp:LayoutParams= LayoutParams(AutoSizeUtils.dp2px(mContext,70.5f),AutoSizeUtils.dp2px(mContext,70.5f))
            lp.setMargins(0,0,AutoSizeUtils.dp2px(mContext,10.0f),0)
            iv.layoutParams=lp
            val options: RequestOptions = RequestOptions
                .bitmapTransform(RoundedCorners(AutoSizeUtils.dp2px(mContext, 12f)))
            Glide.with(mContext).asBitmap()
                .apply(options)
                .load( file.url)
                .into(iv)
            dataBind?.llIalImgs?.addView(iv)

        }

        dataBind?.btnIalEdit?.setOnClickListener()
        {
            //todo 跳转编辑页面
        }




    }
}