package com.xx.merchanthbh.ui.appeallist;

import android.app.Application;
import android.os.Bundle;
import android.util.Log;

import androidx.annotation.NonNull;

import com.xx.merchanthbh.app.ListBaseViewModel;
import com.xx.merchanthbh.data.http.requst.AppealListRequest;
import com.xx.merchanthbh.data.http.respons.AppealListBean;
import com.xx.merchanthbh.ui.appeal.AppealActivity;
import com.xx.merchanthbh.ui.appeal.AppealEditActivity;
import com.xx.merchanthbh.ui.msg.MessageDetailActivity;

import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class AppealListViewModel extends ListBaseViewModel<AppealListRequest> {

    /**
     * 诉求状态:0-待提交,1-待分配,2-已驳回,3-处理中,4-已完成
     */
    String[] appealStatus={"1","2","3","4"};

    public AppealListAdapter adapter;

    public AppealListViewModel(@NonNull Application application) {
        super(application);
    }

    public AppealListViewModel(@NonNull Application application, AppealListRequest model) {
        super(application, model);
    }


    /*跳转诉求详情页*/
    public void goAppealDetail(AppealListAdapter appealListAdapter, int position) {
        /*创建bundle*/
        Bundle bundle = new Bundle();
        /*将要传的businessId传过去*/
        bundle.putString("businessId", appealListAdapter.mList.get(position).getBusinessId());
        Log.v("这是要传过去的businessId",appealListAdapter.mList.get(position).getBusinessId());
        /*连带参数一块跳转到详情页*/
        startActivity(MessageDetailActivity.class, bundle);

    }
    //跳转诉求反馈详情
    public BindingCommand goAppealEdit = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(AppealEditActivity.class);
        }

    });


        public void getAppealList()
    {
        model.getAppealList(appealStatus,page).compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
            .doOnSubscribe(AppealListViewModel.this)
            .doOnSubscribe(new Consumer<Disposable>() {
                @Override
                public void accept(Disposable disposable) throws Exception {
                }
            }).subscribe(new ApiDisposablePageObserver<AppealListBean>() {
                    @Override
                    public void onSuccess(List<AppealListBean> resultBean) {
                        if (page==1)
                        {
                            adapter.mList=resultBean;
                        }else {
                            adapter.mList.addAll(resultBean);
                        }
                        adapter.notifyDataSetChanged();
                    }

                    @Override
                    public void onError(String Error) {

                    }

                    @Override
                    public void getTotal(int total) {
                        if (adapter.mList.size()>=total)
                        {
                            loadMoreStatic.postValue(2);
                        }else {
                            loadMoreStatic.postValue(1);
                        }
                    }
                });
    }

}
