package com.xx.merchanthbh.ui.assistant;

import android.app.Application;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.activity.adapter.AssistantInformationAdapter;
import com.xx.merchanthbh.data.http.requst.AssistantManagementRequest;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.data.http.respons.AssistantInformationBean;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.ui.merchantenter.MerchantEnterViewModel;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class AssistantManagementViewModel extends BaseViewModel<AssistantManagementRequest> {
    //搜索内容绑定
    public ObservableField<String> searchWord = new ObservableField<>("");

    public MutableLiveData<List<AssistantInformationBean>> assistantInformationList = new MutableLiveData<>(new ArrayList<>());

    public AssistantManagementViewModel(@NonNull Application application) {
        super(application);
    }

    public AssistantInformationAdapter adapter;

    public AssistantManagementViewModel(@NonNull Application application, AssistantManagementRequest model) {
        super(application, model);
    }

    //跳转新建店员
    public View.OnClickListener goAssistantAdd = new View.OnClickListener() {
        @Override
        public void onClick(View view) {
            startActivity(AssistantAddActivity.class);
        }
    };


    //搜索店员列表
    public BindingCommand goAssistantMsg = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            geAssistantList();
        }

    });
    //    店员列表赋值
    public void geAssistantList() {
        model.getAssistantList(searchWord.get()).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AssistantManagementViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog("请稍等");
                    }
                }).subscribe(new ApiDisposableObserver<List<AssistantInformationBean>>() {
                    @Override
                    public void onSuccess(List<AssistantInformationBean> resultBean) {

                        /*把接口调出的数据存到bean*/
                        adapter.mList = resultBean;
                        /*适配器刷新*/
                        adapter.notifyDataSetChanged();
                        dismissDialog();
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }

    public void deleteAssistant(AssistantInformationBean bean) {
        model.deleteAssistant(bean.getBusinessId()).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AssistantManagementViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
//                        showDialog("请稍等");
                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {
                    @Override
                    public void onSuccess(Boolean resultBean) {


                        adapter.mList.remove(bean);


                        adapter.notifyDataSetChanged();
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }
}
