package com.xx.merchanthbh.ui.consult;

import android.os.Bundle;

import androidx.lifecycle.Observer;

import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.ConsultRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.databinding.ActivityConsultationListBinding;
import com.xx.merchanthbh.fragment.adapter.ConsultationInformationTitleAdapter;
import com.xx.merchanthbh.fragment.adapter.ConsultationsInformationAdapter;
import com.youth.banner.indicator.CircleIndicator;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class ConsultationActivity extends BaseActivity<ActivityConsultationListBinding,ConsultationViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_consultation_list;
    }

    @Override
    public int initVariableId() {
        return BR.consultationViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        //调用轮播图广告位接口
        viewModel.getADList();
        /* 轮播图 广告遍历*/
        binding.bannerConsult.addBannerLifecycleObserver(this).setIndicator(new CircleIndicator(this));
        viewModel.AdvertisingList.observe(this, new Observer<List<AdvertisingBean>>() {
            @Override
            public void onChanged(List<AdvertisingBean> advertisingBeans) {
                HomeBannerAdapter bannerAdapter = new HomeBannerAdapter(ConsultationActivity.this, advertisingBeans);
                binding.bannerConsult.setAdapter(bannerAdapter);
            }
        });
        /*资讯列表页-资讯信息标题*/
        //获取适配器上下文
        ConsultationInformationTitleAdapter consultationInformationTitleAdapter = new ConsultationInformationTitleAdapter(this);
        //mList赋值
        consultationInformationTitleAdapter.mList = viewModel.consultationTitleBeanList;
        //把adapterset进去
        binding.rvZxtitleList.setAdapter(consultationInformationTitleAdapter);
        //调接口
        viewModel.getConsultationTitle();
        /*资讯信息列表*/
        //获取适配器上下文
        ConsultationsInformationAdapter consultationsInformationAdapter = new ConsultationsInformationAdapter(this);
        //把adapterset进去
        binding.rvZxmsgList.setAdapter(consultationsInformationAdapter);
        viewModel.ConsultationInformationList.observe(this, new Observer<List<ConsultationInformationBean>>() {
            @Override
            public void onChanged(List<ConsultationInformationBean> consultationInformationBeans) {
                consultationsInformationAdapter.mList = consultationInformationBeans;
                consultationsInformationAdapter.notifyDataSetChanged();
            }
        });
        viewModel.getConsultationsList();


    }
    @Override
    public ConsultationViewModel initViewModel() {
        ConsultRequest lm = new ConsultRequest();
        return new ConsultationViewModel(getApplication(), lm);
    }
}
