package com.xx.merchanthbh.ui.consult;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.data.http.requst.ConsultRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.data.http.respons.ConsultationTitleBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class ConsultationViewModel extends BaseViewModel<ConsultRequest> {
    //    创建轮播图广告位实体对象
    public MutableLiveData<List<AdvertisingBean>> AdvertisingList = new MutableLiveData<>(new ArrayList<>());
    //    创建资讯标题实体对象
    public List<ConsultationTitleBean> consultationTitleBeanList = new ArrayList<>();
    //    创建资讯信息实体对象
    public MutableLiveData<List<ConsultationInformationBean>> ConsultationInformationList = new MutableLiveData<>(new ArrayList<>());

    public ConsultationViewModel(@NonNull Application application) {
        super(application);
    }

    public ConsultationViewModel(@NonNull Application application, ConsultRequest model) {
        super(application, model);
    }
    //调用轮播图列表的接口信息
    public void getADList() {
        model.getAdList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ConsultationViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AdvertisingBean>>() {
                    @Override
                    public void onSuccess(List<AdvertisingBean> resultBean) {
                        AdvertisingList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }
    //调用资讯列表的接口信息
    public void getConsultationsList() {
        model.getConsultationInformationList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ConsultationViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<ConsultationInformationBean>>() {
                    @Override
                    public void onSuccess(List<ConsultationInformationBean> resultBean) {
                        ConsultationInformationList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }
    //    资讯标题赋值
    public void getConsultationTitle() {
        consultationTitleBeanList.add(new ConsultationTitleBean("企业风采"));
        consultationTitleBeanList.add(new ConsultationTitleBean("工会信息"));
        consultationTitleBeanList.add(new ConsultationTitleBean("党群信息"));
        consultationTitleBeanList.add(new ConsultationTitleBean("公司年报"));
    }
}
