package com.xx.merchanthbh.ui.home;

import android.os.Bundle;

import androidx.fragment.app.Fragment;

import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.databinding.ActivityHomeBinding;
import com.xx.merchanthbh.ui.huanbohai.HuanBoHaiFragment;
import com.xx.merchanthbh.ui.mine.MineFragment;
import com.google.android.material.bottomnavigation.BottomNavigationView;

import me.goldze.mvvmhabit.base.BaseActivity;

public class HomeActivity extends BaseActivity<ActivityHomeBinding,HomeViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_home;

    }


    @Override
    public void initData() {
        super.initData();
        // 初始化底部导航栏
        BottomNavigationView bottomNavigationView = findViewById(R.id.bottom_navigation_view);
        bottomNavigationView.setOnNavigationItemSelectedListener(navItemSelectedListener);

        // 显示默认的 Fragment
        getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new HomeFragment()).commit();


    }
    @Override
    public int initVariableId() {
        return BR.hmViewModel;
    }

    @Override
    public void onPointerCaptureChanged(boolean hasCapture) {
        super.onPointerCaptureChanged(hasCapture);
    }


    private final BottomNavigationView.OnNavigationItemSelectedListener navItemSelectedListener = item -> {
        Fragment selectedFragment = null;

        // 根据选项 ID 创建相应的 Fragment

        if (item.getItemId() == R.id.menu_home) {
            selectedFragment = new HomeFragment();
        } else if (item.getItemId() == R.id.menu_huanbohai) {
            selectedFragment = new HuanBoHaiFragment();
        }else if (item.getItemId() == R.id.menu_mine) {
            selectedFragment = new MineFragment();
        }


        // 替换当前显示的 Fragment
        // 确保选择项不能为空
        assert selectedFragment != null;
        getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, selectedFragment).commit();
        return true;
    };




}
