package com.xx.merchanthbh.ui.home;

import android.app.Application;
import android.os.Bundle;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;

import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.HomeRequest;
import com.xx.merchanthbh.data.http.respons.HomeStatisticalBean;
import com.xx.merchanthbh.data.http.respons.UserInfoBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.ui.addproduct.AddProductActivity;
import com.xx.merchanthbh.ui.appeal.AppealActivity;
import com.xx.merchanthbh.ui.appeallist.AppealListActivity;
import com.xx.merchanthbh.ui.assistant.AssistantManagementActivity;
import com.xx.merchanthbh.ui.login.LoginViewModel;
import com.xx.merchanthbh.ui.merchantenter.MerchantEnterActivity;
import com.xx.merchanthbh.ui.merchantinfo.MaterialInfoActivity;
import com.xx.merchanthbh.ui.order.OrderActivity;
import com.xx.merchanthbh.ui.ordercreate.OrderCreateActivity;
import com.xx.merchanthbh.ui.point.StorePointsActivity;
import com.xx.merchanthbh.ui.productmanager.ProductManagerActivity;
import com.xx.merchanthbh.ui.recruitment.RecruitmentActivity;
import com.xx.merchanthbh.ui.share.ShareActivity;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class HomeViewModel extends BaseViewModel<HomeRequest> {


    //今日成交的绑定
    public ObservableField<String> totalMoney = new ObservableField<>("");
    //今日订单的绑定
    public ObservableField<String> orderCount = new ObservableField<>("");
    //今日下单用户的绑定
    public ObservableField<String> memberCount = new ObservableField<>("");
    //电费余额的绑定
    public ObservableField<String> electricityBalance = new ObservableField<>("");
    public HomeViewModel(@NonNull Application application) {
        super(application);
    }

    public HomeViewModel(@NonNull Application application, HomeRequest model) {
        super(application, model);
    }

    //跳转添加商品
    public BindingCommand goAddProduct = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(AddProductActivity.class);
        }

    });

    //跳转添加订单
    public BindingCommand goCreateOrder = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(OrderCreateActivity.class);
        }

    });


    //跳转添加商品
    public BindingCommand goProductManager = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(ProductManagerActivity.class);
        }

    });
    //跳转店员管理
    public BindingCommand goAssistantManage = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(AssistantManagementActivity.class);
        }

    });

    //跳转诉求反馈
    public BindingCommand goAppeal = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(AppealListActivity.class);
        }

    });

    //跳转com.xx
    public BindingCommand goPoints = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(StorePointsActivity.class);
        }

    });
    //跳转订单管理
    public BindingCommand goOrder = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(OrderActivity.class);
        }

    });
    //跳转人才招聘
    public BindingCommand goTalent = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(RecruitmentActivity.class);
        }

    });

    //跳转店铺信息
    public BindingCommand goMerchantInfo = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MaterialInfoActivity.class);
        }

    });


    //跳转店铺信息
    public BindingCommand goShareTotal = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(ShareActivity.class);
        }

    });

    /*获取首页统计数据*/
    public void getHomeStatistical() {
        model.getHomeStatistical()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HomeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<HomeStatisticalBean>() {
                    @Override
                    public void onSuccess(HomeStatisticalBean resultBean) {
                        /*今日成交赋值*/
                        totalMoney.set(String.valueOf(resultBean.getTotalMoney()));
                        /*今日订单赋值*/
                        orderCount.set(String.valueOf(resultBean.getOrderCount()));
                        /*今日下单用户赋值*/
                        memberCount.set(String.valueOf(resultBean.getMemberCount()));
                        /*电费余额赋值*/
                        electricityBalance.set(String.valueOf(resultBean.getElectricityBalance()));
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });

    }



}
