package com.xx.merchanthbh.ui.huanbohai;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;

import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.HuanBoHaiRequest;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.databinding.FragmentHuanbohaiBinding;
import com.xx.merchanthbh.fragment.adapter.ActivityCenterListAdapter;
import com.xx.merchanthbh.fragment.adapter.ConsultationInformationAdapter;
import com.xx.merchanthbh.fragment.adapter.ConsultationInformationTitleAdapter;
import com.youth.banner.indicator.CircleIndicator;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

/*环渤海页面*/
public class HuanBoHaiFragment extends BaseFragment<FragmentHuanbohaiBinding, HuanBoHaiViewModel> {

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        //展示活动列表
        ActivityCenterListAdapter adapter = new ActivityCenterListAdapter(requireContext());

        binding.rvDblList.setAdapter(adapter);

        viewModel.ActivityCenterList.observe(this, new Observer<List<ActivityCenterBean>>() {
            @Override
            public void onChanged(List<ActivityCenterBean> activityCenterBeans) {
                adapter.mList=activityCenterBeans;
                adapter.notifyDataSetChanged();
            }
        });

        /*环渤海-资讯信息标题*/
        //获取适配器上下文
        ConsultationInformationTitleAdapter consultationInformationTitleAdapter = new ConsultationInformationTitleAdapter(requireContext());
        //mList赋值
        consultationInformationTitleAdapter.mList = viewModel.consultationTitleBeanList;
        //把adapterset进去
        binding.rvZxtitleList.setAdapter(consultationInformationTitleAdapter);
        viewModel.getConsultationTitle();


        /*环渤海-资讯信息列表*/
        //获取适配器上下文
        ConsultationInformationAdapter consultationInformationAdapter = new ConsultationInformationAdapter(requireContext());

        //把adapterset进去
        binding.rvZxmsgList.setAdapter(consultationInformationAdapter);
        viewModel.ConsultationInformationList.observe(this, new Observer<List<ConsultationInformationBean>>() {
            @Override
            public void onChanged(List<ConsultationInformationBean> consultationInformationBeans) {
                consultationInformationAdapter.mList = consultationInformationBeans;
                consultationInformationAdapter.notifyDataSetChanged();
            }
        });

        binding.bannerHbh.addBannerLifecycleObserver(this).setIndicator(new CircleIndicator(requireContext()));
        viewModel.AdvertisingList.observe(this, new Observer<List<AdvertisingBean>>() {
            @Override
            public void onChanged(List<AdvertisingBean> advertisingBeans) {
                HbhBannerAdapter bannerAdapter=new HbhBannerAdapter(requireContext(),advertisingBeans);
                binding.bannerHbh.setAdapter(bannerAdapter);
            }
        });

    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {

        return R.layout.fragment_huanbohai;

    }

    @Override
    public int initVariableId() {
        return BR.huanbohaiViewModel;
    }


    @Override
    public HuanBoHaiViewModel initViewModel() {
//        List<Integer> list = new ArrayList<>();
        HuanBoHaiRequest lm = new HuanBoHaiRequest();
        return new HuanBoHaiViewModel(getActivity().getApplication(), lm);
    }
}