package com.xx.merchanthbh.ui.huanbohai;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.data.http.requst.HuanBoHaiRequest;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.data.http.respons.MerchantBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.data.http.respons.ConsultationTitleBean;
import com.xx.merchanthbh.ui.activities.ActivitiesActivity;
import com.xx.merchanthbh.ui.appeal.AppealDetailActivity;
import com.xx.merchanthbh.ui.appeal.AppealEditActivity;
import com.xx.merchanthbh.ui.consult.ConsultationActivity;
import com.xx.merchanthbh.ui.msg.MessageActivity;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class HuanBoHaiViewModel extends BaseViewModel<HuanBoHaiRequest> {

    //    创建活动中心实体对象
    public MutableLiveData<List<AdvertisingBean>> AdvertisingList =new  MutableLiveData<>(new ArrayList<>());
    //    创建活动中心实体对象
    public MutableLiveData<List<ActivityCenterBean>> ActivityCenterList =new  MutableLiveData<>(new ArrayList<>());
    //    创建资讯信息实体对象
    public MutableLiveData<List<ConsultationInformationBean>> ConsultationInformationList =new  MutableLiveData<>(new ArrayList<>());
    //    创建资讯标题实体对象
    public List<ConsultationTitleBean> consultationTitleBeanList = new ArrayList<>();

    public MerchantBean merchantInfo= LocalData.getMerchant();

    public HuanBoHaiViewModel(@NonNull Application application) {
        super(application);
    }

    public HuanBoHaiViewModel(@NonNull Application application, HuanBoHaiRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        getADList();
        getConsultationsList();
        getActivityCenterList();
    }
    public void getConsultationTitle() {
        consultationTitleBeanList.add(new ConsultationTitleBean("企业风采"));
        consultationTitleBeanList.add(new ConsultationTitleBean("工会信息"));
        consultationTitleBeanList.add(new ConsultationTitleBean("党群信息"));
        consultationTitleBeanList.add(new ConsultationTitleBean("公司年报"));
    }
    //调用活动中心的接口信息
    public void getActivityCenterList() {
        model.getActivityList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HuanBoHaiViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<ActivityCenterBean>>() {
                    @Override
                    public void onSuccess(List<ActivityCenterBean> resultBean) {
                        ActivityCenterList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }
    //调用资讯列表的接口信息
    public void getConsultationsList() {
        model.getConsultationInformationList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HuanBoHaiViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<ConsultationInformationBean>>() {
                    @Override
                    public void onSuccess(List<ConsultationInformationBean> resultBean) {
                        ConsultationInformationList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }


    /**
     * 获取banner
     */
    public void getADList() {
        model.getAdList(merchantInfo.getBooth().getAffiliatedCompany())
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HuanBoHaiViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AdvertisingBean>>() {
                    @Override
                    public void onSuccess(List<AdvertisingBean> resultBean) {
                        AdvertisingList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }
    //跳转活动中心界面
    public BindingCommand goActivities = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(ActivitiesActivity.class);
        }

    });
    //跳转消息中心界面
    public BindingCommand goMessage = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MessageActivity.class);
        }

    });
    //跳转诉求详情界面
    public BindingCommand goDetail = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(AppealDetailActivity.class);
        }

    });
    //跳转诉求编辑界面
    public BindingCommand goEdit = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(AppealEditActivity.class);
        }

    });
    //跳转资讯列表界面
    public BindingCommand goConsultation = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(ConsultationActivity.class);
        }

    });

}