package com.xx.merchanthbh.ui.login

import android.content.Intent
import android.net.Uri
import android.os.Build
import android.os.Bundle
import android.os.Environment
import android.provider.Settings
import android.text.SpannableStringBuilder
import android.text.Spanned
import android.text.TextPaint
import android.text.style.ClickableSpan
import android.view.View
import com.xx.merchanthbh.BR
import com.xx.merchanthbh.R
import com.xx.merchanthbh.data.http.requst.LoginRequest
import com.xx.merchanthbh.databinding.ActivityLoginBinding
import me.goldze.mvvmhabit.base.BaseActivity

class LoginActivity() : BaseActivity<ActivityLoginBinding, LoginViewModel>() {


    override fun initContentView(savedInstanceState: Bundle?): Int {

        return R.layout.activity_login

    }

    override fun initVariableId(): Int {
        return BR.loginViewModel
    }

    override fun initData() {


        super.initData()
        if(Build.VERSION.SDK_INT>=Build.VERSION_CODES.R)
        {

            if (!Environment.isExternalStorageManager())
            {
                val intent = Intent(Settings.ACTION_MANAGE_APP_ALL_FILES_ACCESS_PERMISSION)
                intent.setData(Uri.parse("package:$packageName"))
                startActivityForResult(intent, 1024)
            }
        }
        if (viewModel.isAgree)
        {
            binding.ivLoginAgreement.setImageDrawable(getDrawable(R.mipmap.login_icon_xuanze2))
        }else{
            binding.ivLoginAgreement.setImageDrawable(getDrawable(R.mipmap.login_icon_xuanze1))
        }


        binding.ivLoginAgreement.setOnClickListener()
        {
            if (viewModel.isAgree)
            {
                viewModel.isAgree=false
                binding.ivLoginAgreement.setImageDrawable(getDrawable(R.mipmap.login_icon_xuanze1))
            }else{
                viewModel.isAgree=true
                binding.ivLoginAgreement.setImageDrawable(getDrawable(R.mipmap.login_icon_xuanze2))
            }
        }


        var sp:SpannableStringBuilder= SpannableStringBuilder("我已阅读并同意《用户协议》、《隐私条款》")
//        sp.setSpan(ForegroundColorSpan(getColor(R.color.text_grey_blue)),7,20,Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)

        sp.setSpan(object : ClickableSpan() {
            override fun onClick(view: View) {

            }

            override fun updateDrawState(ds: TextPaint) {
                ds.setColor(getColor(R.color.text_grey_blue))
                ds.isUnderlineText=false

            }
        },7,13,Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)

        sp.setSpan(object : ClickableSpan() {
            override fun onClick(view: View) {

            }

            override fun updateDrawState(ds: TextPaint) {
                ds.setColor(getColor(R.color.text_grey_blue))
                ds.isUnderlineText=false

            }
        },14,20,Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)

       binding.tvLoginAgree.text=sp

    }

    override fun initViewObservable() {
        super.initViewObservable()
    }

    override fun initViewModel(): LoginViewModel {
        val lm: LoginRequest = LoginRequest()
        return LoginViewModel(application,lm)
    }

}