package com.xx.merchanthbh.ui.merchantenter;

import static me.goldze.mvvmhabit.utils.Utils.Interceptor_TOKEN;

import android.app.Application;
import android.text.TextUtils;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;
import androidx.navigation.NavController;
import androidx.navigation.Navigation;

import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.MerchantEnterRequst;
import com.xx.merchanthbh.data.http.requst.body.BrankBean;
import com.xx.merchanthbh.data.http.requst.body.Brankbody;
import com.xx.merchanthbh.data.http.requst.body.MerchantMsgbody;
import com.xx.merchanthbh.data.http.respons.BoothBean;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.http.respons.RegisterBean;
import com.xx.merchanthbh.data.http.respons.UserBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.dialog.BoothListDialog;
import com.xx.merchanthbh.ui.addproduct.data.TextListProvider;
import com.xx.xxviewlibrary.base.xxBaseDialog;
import com.xx.xxviewlibrary.comm.CommTextDialog;
import com.xx.xxviewlibrary.comm.RefuseDialogBean;
import com.xx.xxviewlibrary.witget.model.FileBean;
import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.BaseResponse;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class MerchantEnterViewModel extends BaseViewModel<MerchantEnterRequst> {
    public ObservableField<String> title = new ObservableField<>("");

    public ObservableField<String> pwds = new ObservableField<>("");

    public RegisterModel registerBody=new RegisterModel();

    public List<BoothBean> boothBeanList=new ArrayList<>();


    public String userStatic=null;
    /**
     * 通知添加品牌
     */
    public MutableLiveData<List<Brankbody>> addbrank=new MutableLiveData<>(new ArrayList<>());


    public UserBean user;
    public MerchantEnterRequst.MerchantInfo merchantInfo;



    /**
     * 商家入驻全部内容
     */
    public class RegisterModel
    {
        public ObservableField<String> oPhone = new ObservableField<String>("");

        public ObservableField<String> oCode = new ObservableField<String>("");

        public ObservableField<String> oPassword = new ObservableField<String>("");

    }




    public MerchantEnterViewModel(@NonNull Application application) {
        super(application);
        model= new MerchantEnterRequst();
        if(!TextUtils.isEmpty(Interceptor_TOKEN))
        {

            user=LocalData.getUser();
            merchantInfo=new MerchantEnterRequst.MerchantInfo(user.getPhonenumber());
        }



    }

    public MerchantEnterViewModel(@NonNull Application application, MerchantEnterRequst model) {
        super(application, model);
    }

    /**
     * 跳转注册
     * @param view
     */
    public void goRegister(View view)
    {

        NavController navController= Navigation.findNavController(view);
        navController.navigate(R.id.action_merchantIntroduceFragment_to_merchantRegisterFragment);
    }


    /**
     * 获取图片
     */
    public BindingCommand getPhoto = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startPhotoPage(true, new SelectCallback() {
                @Override
                public void onResult(ArrayList<Photo> photos, boolean isOriginal) {

                    /*Bitmap mBitmap = BitmapFactory.decodeFile(photos.get(0).path);*/

                    File file = new File(photos.get(0).path);
                    model.upLoadFile(file).compose(RxUtils.schedulersTransformer()) //线程调度
                            .doOnSubscribe(MerchantEnterViewModel.this)
                            .doOnSubscribe (new Consumer<Disposable>() {
                                @Override
                                public void accept(Disposable disposable) throws Exception {
                                    showDialog("请稍等");
                                }
                            }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                                @Override
                                public void onSuccess(List<Filebean> resultBean) {
                                    dismissDialog();
                                }

                                @Override
                                public void onError(String Error) {
                                    dismissDialog();
                                }


                            });
                }

                @Override
                public void onCancel() {

                }
            });
        }

    });


    /**
     * 获取验证码
     */
    public BindingCommand getCode = new BindingCommand(new BindingAction() {
        @Override
        public void call() {

            if (TextUtils.isEmpty(registerBody.oPhone.get()))
            {
                ToastUtils.showShort("请输入手机号！");
                return;
            }
            model.getCode(registerBody.oPhone.get())
                    .compose(RxUtils.schedulersTransformer()) //线程调度
                    .doOnSubscribe(MerchantEnterViewModel.this)
                    .doOnSubscribe (new Consumer<Disposable>() {
                        @Override
                        public void accept(Disposable disposable) throws Exception {
                            showDialog("正在获取验证码");
                        }
                    }).subscribe(new ApiDisposableObserver<String>() {
                        @Override
                        public void onSuccess(String resultBean) {
                            ToastUtils.showShort("已经发送成功");
                            dismissDialog();
                        }

                        @Override
                        public void onError(String Error) {
                            dismissDialog();
                        }


                    });
        }
    });


    /**
     * 注册
     * @param view
     */
    public void register(View view)
    {
        if (!pwds.get().equals(registerBody.oPassword.get()))
        {
            ToastUtils.showShort("两次密码输入不一致！");
            return;
        }

        model.register(registerBody)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MerchantEnterViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog("正在加载");
                    }
                }).subscribe(new ApiDisposableObserver<RegisterBean>() {
                    @Override
                    public void onSuccess(RegisterBean resultBean) {
                        ToastUtils.showShort("成功");
                        Login(view);


                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    /**
     * 登陆
     * @param view
     */
    public void Login(View view)
    {
        model.Login(registerBody)
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(MerchantEnterViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<String>() {
                    @Override
                    public void onSuccess(String resultBean) {
                        //是指token
                        dismissDialog();
                        Interceptor_TOKEN="Bearer "+resultBean;

                        merchantInfo=new MerchantEnterRequst.MerchantInfo(registerBody.oPhone.get());
                        NavController navController= Navigation.findNavController(view);
                        navController.navigate(R.id.action_merchantRegisterFragment_to_registerMaterialFragment);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }

    /**
     * 获取展位列表
     */
    public void getBoothList()
    {model.getBoothList()
            .compose(RxUtils.schedulersTransformer()) //线程调度
            .doOnSubscribe(MerchantEnterViewModel.this)
            .doOnSubscribe (new Consumer<Disposable>() {
                @Override
                public void accept(Disposable disposable) throws Exception {
                }
            }).subscribe(new ApiDisposableObserver<List<BoothBean>>() {
                @Override
                public void onSuccess(List<BoothBean> resultBean) {
                    boothBeanList.clear();
                    boothBeanList.addAll(resultBean);
                }

                @Override
                public void onError(String Error) {
                    dismissDialog();
                }


            });}


    public void openBooth(View view)
    {
        BoothListDialog dialoh=new BoothListDialog(view.getContext(),boothBeanList);
        dialoh.setDialogClickListener(new xxBaseDialog.onDialogClickListener<TextListProvider>() {
            @Override
            public void dialogClickBack(int code, TextListProvider data) {

                merchantInfo.getBoothNum().set(data.providerText());
                merchantInfo.setBoothId(data.ProviderId());
            }
        });

        dialoh.show();
    }


    /**
     * 添加品牌
     * @param view
     */
    public void addBrank(View view)
    {
        addbrank.postValue(merchantInfo.getBranklist());
    }


    /**
     * 上传图片类信息
     * @param view
     */
    public void uploadPic(View view)
    {
        //选择图片
        startPhotoPage(true, new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {
                model.upLoadFile(new File(photos.get(0).path)).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(MerchantEnterViewModel.this)
                        .doOnSubscribe (new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog();
                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {
                                dismissDialog();
                                FileBean bean= new FileBean(resultBean.get(0).getBusinessId(),resultBean.get(0).getUrl());


                                if (view.getId()==R.id.xup_frm_logo)
                                {
                                    merchantInfo.getCompanyLogo().set(bean);
                                }else if (view.getId()==R.id.xup_frm_licence)
                                {
                                    merchantInfo.getOperatingPermit().set(bean);
                                }else if (view.getId()==R.id.xup_frm_business_license)
                                {
                                    merchantInfo.getBusinessLicense().set(bean);
                                }

                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }


    /**
     * 提交商户信息
     * @param view
     */
    public void submitMerchantMsg(View view)
    {
        Observable<BaseResponse<Boolean>> observable;
        if (
               TextUtils.isEmpty(userStatic)
        )
        {
            observable= model.postMerchantMsg(new MerchantMsgbody(merchantInfo));
        }else {
            MerchantMsgbody mb= new MerchantMsgbody(merchantInfo);
            mb.setBusinessId(userStatic);
            observable=model.postREMerchantMsg(mb);
        }
        observable.compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MerchantEnterViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog();
                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {
                    @Override
                    public void onSuccess(Boolean resultBean) {
                        dismissDialog();
                        NavController navController= Navigation.findNavController(view);
                        navController.navigate(R.id.action_registerMaterialFragment_to_merchantWaitFragment);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }

    /**
     * 展示驳回原因
     * @param view
     */
    public void showReason(View view)
    {
        showCommTextDialog(new RefuseDialogBean(LocalData.getMerchant().getRemark(),"确认",null,"审核意见"), new CommTextDialog.onAcceptCallBack() {
            @Override
            public void acceptBack() {

            }

            @Override
            public void refuseBack() {

            }
        });

    }


}
