package com.xx.merchanthbh.ui.merchantinfo;


import android.app.Application;
import android.text.TextUtils;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;
import androidx.navigation.NavController;
import androidx.navigation.Navigation;

import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;
import com.huantansheng.easyphotos.utils.permission.PermissionUtil;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.MerchantEnterRequst;
import com.xx.merchanthbh.data.http.requst.body.BrankBean;
import com.xx.merchanthbh.data.http.requst.body.Brankbody;
import com.xx.merchanthbh.data.http.requst.body.MerchantMsgbody;
import com.xx.merchanthbh.data.http.respons.BoothBean;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.http.respons.MerchantBean;
import com.xx.merchanthbh.data.http.respons.RegisterBean;
import com.xx.merchanthbh.data.http.respons.UserBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.dialog.BoothListDialog;
import com.xx.merchanthbh.ui.merchantenter.AddBrankAdapter;
import com.xx.xxviewlibrary.base.xxBaseDialog;
import com.xx.xxviewlibrary.witget.model.FileBean;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class MerchantInfoViewModel extends BaseViewModel<MerchantEnterRequst> {



    public AddBrankAdapter adapter;
    public UserBean user;
    public MerchantEnterRequst.MerchantInfo merchantInfo;


    public MutableLiveData<MerchantBean> merchantInfos=new MutableLiveData<>();

    public MerchantInfoViewModel(@NonNull Application application) {
        super(application);
        model= new MerchantEnterRequst();
        user=LocalData.getUser();
        merchantInfo=new MerchantEnterRequst.MerchantInfo("138");
    }

    public MerchantInfoViewModel(@NonNull Application application, MerchantEnterRequst model) {
        super(application, model);

    }


    /**
     * 获取图片
     */
    public BindingCommand getPhoto = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startPhotoPage(true, new SelectCallback() {
                @Override
                public void onResult(ArrayList<Photo> photos, boolean isOriginal) {

                    /*Bitmap mBitmap = BitmapFactory.decodeFile(photos.get(0).path);*/

                    File file = new File(photos.get(0).path);
                    model.upLoadFile(file).compose(RxUtils.schedulersTransformer()) //线程调度
                            .doOnSubscribe(MerchantInfoViewModel.this)
                            .doOnSubscribe (new Consumer<Disposable>() {
                                @Override
                                public void accept(Disposable disposable) throws Exception {
                                    showDialog("请稍等");
                                }
                            }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                                @Override
                                public void onSuccess(List<Filebean> resultBean) {

                                    dismissDialog();
                                }

                                @Override
                                public void onError(String Error) {
                                    dismissDialog();
                                }


                            });
                }

                @Override
                public void onCancel() {

                }
            });
        }

    });





    /**
     * 添加品牌
     * @param view
     */
    public void addBrank(View view)
    {
        adapter.mList.add(new Brankbody());
        adapter.notifyDataSetChanged();
    }


    /**
     * 上传图片类信息
     * @param view
     */
    public void uploadPic(View view)
    {
        //选择图片
        startPhotoPage(true, new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {
                model.upLoadFile(new File(photos.get(0).path)).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(MerchantInfoViewModel.this)
                        .doOnSubscribe (new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog();
                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {
                                dismissDialog();
                                FileBean bean= new FileBean(resultBean.get(0).getBusinessId(),resultBean.get(0).getUrl());


                                if (view.getId()==R.id.xup_frm_logo)
                                {
                                    merchantInfo.getCompanyLogo().set(bean);
                                }else if (view.getId()==R.id.xup_frm_licence)
                                {
                                    merchantInfo.getOperatingPermit().set(bean);
                                }else if (view.getId()==R.id.xup_frm_business_license)
                                {
                                    merchantInfo.getBusinessLicense().set(bean);
                                }

                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }


    /**
     * 提交商户信息
     * @param view
     */
    public void submitMerchantMsg(View view)
    {
        model.postChangeMerchantMsg(new MerchantMsgbody(merchantInfo)).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MerchantInfoViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog();
                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {
                    @Override
                    public void onSuccess(Boolean resultBean) {
                        dismissDialog();

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }

    /**
     * 获取详情
     */
    public void getMerchantInfo()
    {

        model.getMerchantInfoById().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MerchantInfoViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<MerchantBean>() {
                    @Override
                    public void onSuccess(MerchantBean resultBean) {
                        merchantInfo.setMerchantInfo(resultBean);
                        merchantInfos.postValue(resultBean);
                        adapter.mList=merchantInfo.reBrankbody(resultBean.getBrandAuthorizationList());
                        adapter.notifyDataSetChanged();
                    }

                    @Override
                    public void onError(String Error) {

                    }

                });
    }


}
