package com.xx.merchanthbh.ui.mine;

import static com.xx.merchanthbh.utils.RetrofitClient.baseImgUrl;

import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;
import com.bumptech.glide.load.resource.drawable.DrawableTransitionOptions;
import com.bumptech.glide.request.RequestOptions;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.databinding.FragmentMineBinding;

import me.goldze.mvvmhabit.base.BaseFragment;

public class MineFragment extends BaseFragment<FragmentMineBinding, MineViewModel> {


    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_mine;
    }

    @Override
    public int initVariableId() {
        return BR.mineViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
//        super.initData();
        // 调用ViewModel的方法来刷新昵称
        ((MineViewModel) viewModel).refreshNickName();
        Log.v("这是传参传参传参的图片路径", String.valueOf(viewModel.getAvatarImageUrl()));
        /*控制台拿到了图片路径了*/
        /*如果图片有刷新就会进行更新*/
        viewModel.getAvatarImageUrl().observe(this, new Observer<String>() {
            @Override
            public void onChanged(String imageUrl) {
                if (imageUrl != null) {
                    // 设置圆角半径
                    int radius = 120;
                    // 创建圆角转换器
                    RoundedCorners roundedCorners = new RoundedCorners(radius);
                    // 创建Glide请求选项
                    RequestOptions requestOptions = RequestOptions.bitmapTransform(roundedCorners);
                    // 使用Glide加载图片并应用圆角转换器
                    Glide.with(MineFragment.this)
                            .load(baseImgUrl+imageUrl)
                            .apply(requestOptions)
                            .transition(DrawableTransitionOptions.withCrossFade())
                            .into(binding.imageAvatar);
                }
            }
        });

    }
}