package com.xx.merchanthbh.ui.mine;

import android.app.Application;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.data.http.requst.MineRequest;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.ui.phone.PhoneActivity;
import com.xx.merchanthbh.ui.pwd.PwdActivity;

import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;

public class MineViewModel extends BaseViewModel<MineRequest> {
    //头像的绑定
    private MutableLiveData<String> avatarImageUrl = new MutableLiveData<>();
    //昵称的绑定
    public ObservableField<String> nickName = new ObservableField<>("");
    //创建时间的绑定
    public ObservableField<String> createTime = new ObservableField<>("");
    //职位的绑定
    public ObservableField<String> roleName = new ObservableField<>("");

    public MineViewModel(@NonNull Application application) {
        super(application);
    }

    public MineViewModel(@NonNull Application application, MineRequest model) {
        super(application, model);
    }
    private void setValueToNickName() {
        nickName.set(LocalData.getUser().getNickName());
        createTime.set(LocalData.getUser().getCreateTime());
        roleName.set(LocalData.getUser().getRoles().get(0).getRoleName());
        avatarImageUrl.setValue(LocalData.getUser().getAvatar());
        Log.v("还在viewModel滞留的图片", String.valueOf(avatarImageUrl));

    }
    /*头像回显*/
    public LiveData<String> getAvatarImageUrl() {
        return avatarImageUrl;
    }
    public void refreshNickName() {
        setValueToNickName();
    }
    //跳转修改密码界面
    public BindingCommand goChangePwd = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(PwdActivity.class);
        }

    });
    //跳转修改手机号界面
    public BindingCommand goChangePhone = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(PhoneActivity.class);
        }

    });
}