package com.xx.merchanthbh.ui.msg;


import android.os.Bundle;

import androidx.lifecycle.Observer;

import com.google.android.material.tabs.TabLayout;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.activity.adapter.MessageListAdapter;
import com.xx.merchanthbh.data.http.requst.MessageRequest;
import com.xx.merchanthbh.data.http.respons.MessageBean;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.ActivityMessageBinding;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class MessageActivity extends BaseActivity<ActivityMessageBinding, MessageViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_message;
    }

    @Override
    public int initVariableId() {
        return BR.messageViewModel;
    }
    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();

        //获取适配器上下文
        MessageListAdapter messageListAdapter = new MessageListAdapter(this);

        //把adapterset进去
        binding.rvOrderList.setAdapter(messageListAdapter);
        // 对列表遍历项设置点击事件
        messageListAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<MessageBean>() {
            /*返回位置参数*/
            @Override
            public void itemClickCalBack(int position, MessageBean data) {
                /*将上下文和位置参数给方法*/
                viewModel.goMessageDetail(messageListAdapter, position);
            }
        });
        /*对订单列表内容进行遍历回显*/
        viewModel.messageList.observe(this, new Observer<List<MessageBean>>() {
            @Override
            public void onChanged(List<MessageBean> orderBeanList) {
                messageListAdapter.mList = orderBeanList;
                /*实时更新*/
                messageListAdapter.notifyDataSetChanged();
            }
        });
        /*调消息列表接口*/
        viewModel.getMessageList();


        /*切换状态Tab*/
        binding.tabs.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            /*消息状态 1-未读 2-已读*/
            public void onTabSelected(TabLayout.Tab tab) {
                messageListAdapter.mList.clear();
                switch (tab.getPosition()) {
                    case 0:
                        viewModel.flag = "0";
                        /*flag 0-未读 1-已读*/
                        StaticData.flag = 0;
                        viewModel.getMessageList();
                        break;
                    case 1:
                        viewModel.flag = "1";
                        /*flag 0-未读 1-已读*/
                        StaticData.flag = 1;
                        viewModel.getMessageList();
                        break;
                }
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });
    }

    //    重写初始方法调用参数
    @Override
    public void initViewObservable() {
        super.initViewObservable();
    }
    @Override
    public MessageViewModel initViewModel() {
        MessageRequest lm = new MessageRequest();
        return new MessageViewModel(getApplication(), lm);
    }
}
