package com.xx.merchanthbh.ui.order;

import android.os.Bundle;

import androidx.lifecycle.Observer;

import com.google.android.material.tabs.TabLayout;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.activity.adapter.OrderListAdapter;
import com.xx.merchanthbh.data.http.requst.OrderRequest;
import com.xx.merchanthbh.data.http.respons.OrderBean;
import com.xx.merchanthbh.databinding.ActivityOrderManagementBinding;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class OrderActivity extends BaseActivity<ActivityOrderManagementBinding, OrderViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_order_management;
    }

    @Override
    public int initVariableId() {
        return BR.orderViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        //获取适配器上下文
        OrderListAdapter orderListAdapter = new OrderListAdapter(this);

        //把adapterset进去
        binding.rvOrderList.setAdapter(orderListAdapter);
        // 对列表遍历项设置点击事件
        orderListAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<OrderBean>() {
            /*返回位置参数*/
            @Override
            public void itemClickCalBack(int position, OrderBean data) {
                /*将上下文和位置参数给方法*/
                viewModel.goOrderDetail(orderListAdapter, position);
            }
        });
        /*对订单列表内容进行遍历回显*/
        viewModel.orderList.observe(this, new Observer<List<OrderBean>>() {
            @Override
            public void onChanged(List<OrderBean> orderBeanList) {
                orderListAdapter.mList = orderBeanList;
                /*实时更新*/
                orderListAdapter.notifyDataSetChanged();
            }
        });
        //调接口
        viewModel.getOrderList();

        /*切换状态Tab*/
        binding.tabs.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            /*订单状态 1-待付款 2-已完成 3-已关闭*/
            public void onTabSelected(TabLayout.Tab tab) {
                orderListAdapter.mList.clear();
                switch (tab.getPosition()) {
                    case 0:
                        viewModel.orderStatus = "";
                        viewModel.getOrderList();
                        break;
                    case 1:
                        viewModel.orderStatus = "1";
                        viewModel.getOrderList();
                        break;
                    case 2:
                        viewModel.orderStatus = "2";
                        /*状态位存储留给详情页用*/
                        viewModel.getOrderList();
                        break;
                    case 3:
                        viewModel.orderStatus = "3";
                        viewModel.getOrderList();
                        break;
                }
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });
    }

    //    重写初始方法调用参数
    @Override
    public void initViewObservable() {
        super.initViewObservable();
    }

    @Override
    public OrderViewModel initViewModel() {
        OrderRequest lm = new OrderRequest();
        return new OrderViewModel(getApplication(), lm);
    }
}
