package com.xx.merchanthbh.ui.order;


import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.activity.adapter.OrderListAdapter;
import com.xx.merchanthbh.activity.adapter.OrderUnitAdapter;
import com.xx.merchanthbh.activity.adapter.OrderUnitUnitAdapter;
import com.xx.merchanthbh.data.http.requst.OrderDetailRequest;
import com.xx.merchanthbh.data.http.respons.OrderBean;
import com.xx.merchanthbh.data.http.respons.OrderDetailBean;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.ActivityOrderDetailBinding;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class OrderDetailActivity extends BaseActivity<ActivityOrderDetailBinding, OrderDetailViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_order_detail;
    }

    @Override
    public int initVariableId() {
        return BR.orderDetailViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();

        // 创建RecyclerView的适配器
        OrderUnitUnitAdapter orderUnitUnitAdapter = new OrderUnitUnitAdapter(this);
        Log.v("这是传过来的getCommodityList的数据", viewModel.orderDetailList.toString());

        viewModel.businessId=businessId;
        //把adapterset进去
        binding.rvOrderUnit.setAdapter(orderUnitUnitAdapter);
        viewModel.orderDetailList.observe(this, new Observer<List<OrderDetailBean.CommodityLists>>() {
            @Override
            public void onChanged(List<OrderDetailBean.CommodityLists> commodityLists) {
                /*设置内层列表值*/
                orderUnitUnitAdapter.mList = commodityLists;
                orderUnitUnitAdapter.notifyDataSetChanged();
            }
        });
        // 调用ViewModel的方法来刷新昵称
        ((OrderDetailViewModel) viewModel).refreshNickName();
        /*调用接口*/
        viewModel.getOrderDetailInfo();
        /*订单状态-待付款*/
        if (StaticData.statusObligation == 1) {
            binding.statusObligationId.setVisibility(View.VISIBLE);
        } else {
            binding.statusObligationId.setVisibility(View.GONE);
        }
        /*订单状态-已完成*/
        if (StaticData.statusCompleted == 1) {
            binding.statusCompletedId.setVisibility(View.VISIBLE);
        } else {
            binding.statusCompletedId.setVisibility(View.GONE);
        }
        /*订单状态-已关闭*/
        if (StaticData.statusClosed == 1) {
            binding.statusClosedId.setVisibility(View.VISIBLE);
        } else {
            binding.statusClosedId.setVisibility(View.GONE);
        }
    }

    @Override
    public OrderDetailViewModel initViewModel() {
        OrderDetailRequest lm = new OrderDetailRequest();
        return new OrderDetailViewModel(getApplication(), lm);
    }
}
