package com.xx.merchanthbh.ui.productmanager

import android.os.Bundle
import com.google.android.material.tabs.TabLayout
import com.xx.merchanthbh.BR
import com.xx.merchanthbh.R
import com.xx.merchanthbh.data.http.requst.ProductManagerRequst
import com.xx.merchanthbh.databinding.ActivityProductListBinding
import me.goldze.mvvmhabit.base.BaseActivity

class ProductManagerActivity: BaseActivity<ActivityProductListBinding, ProductManagerViewModel>() {
    override fun initContentView(savedInstanceState: Bundle?): Int {
        return R.layout.activity_product_list
    }

    override fun initVariableId(): Int {
        return BR.viewModel
    }

    override fun initData() {
        super.initData()
        viewModel.listAdapter= ProductListAdapter(this,viewModel)
        binding.rvProductList.adapter= viewModel.listAdapter
        viewModel.getProductList()
        binding.tabs.addOnTabSelectedListener(object: TabLayout.OnTabSelectedListener
        {
            override fun onTabSelected(tab: TabLayout.Tab?) {
                viewModel.pageNum=1
                viewModel.listAdapter.mList.clear()
                when(tab?.position)
                {
                    0-> viewModel.listStatic=null
                    1-> viewModel.listStatic="1"
                    2-> viewModel.listStatic="2"
                    3-> viewModel.listStatic="3"
                    4-> viewModel.listStatic="5"
                    5-> viewModel.listStatic="4"
                }
                viewModel.getProductList()
            }

            override fun onTabUnselected(tab: TabLayout.Tab?) {
            }

            override fun onTabReselected(tab: TabLayout.Tab?) {
            }

        })

    }

    override fun initViewModel(): ProductManagerViewModel {
        val lm: ProductManagerRequst = ProductManagerRequst()
        return ProductManagerViewModel(application,lm)
    }


}