package com.xx.merchanthbh.ui.productmanager;

import android.app.Application;
import android.view.View;

import androidx.annotation.NonNull;

import com.xx.merchanthbh.data.http.requst.ProductManagerRequst;
import com.xx.merchanthbh.data.http.respons.ProductListBean;
import com.xx.merchanthbh.data.http.respons.UserInfoBean;
import com.xx.merchanthbh.ui.login.LoginViewModel;
import com.xx.xxviewlibrary.comm.CommTextDialog;
import com.xx.xxviewlibrary.comm.RefuseDialogBean;

import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class ProductManagerViewModel extends BaseViewModel<ProductManagerRequst> {


    public int pageNum=1;

    public String listStatic=null;
    public ProductListAdapter listAdapter;

    public ProductManagerViewModel(@NonNull Application application, ProductManagerRequst model) {
        super(application, model);
    }


    /**
     * 获取商品列表
     */
    public void getProductList()
    {
        model.getProductList(listStatic,"0",1).compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
            .doOnSubscribe(ProductManagerViewModel.this)
            .doOnSubscribe(new Consumer<Disposable>() {
                @Override
                public void accept(Disposable disposable) throws Exception {
                }
            }).subscribe(new ApiDisposablePageObserver<ProductListBean>() {

                    @Override
                    public void onSuccess(List<ProductListBean> resultBean) {
                        listAdapter.mList=resultBean;
                        listAdapter.notifyDataSetChanged();
                    }

                    @Override
                    public void onError(String Error) {

                    }

                    @Override
                    public void getTotal(int total) {

                    }
                });
    }


    public void deleteClick(ProductListBean bean)
    {

        showCommTextDialog(new RefuseDialogBean("删除后商品不可回复，是否继续", "确认", "取消", "提示"), new CommTextDialog.onAcceptCallBack() {
            @Override
            public void acceptBack() {
                model.deleteProduct(bean.getBusinessId()).compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                        .doOnSubscribe(ProductManagerViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                            }
                        }).subscribe(new ApiDisposableObserver<Integer>() {

                            @Override
                            public void onSuccess(Integer resultBean) {
                                listAdapter.mList.remove(bean);
                                listAdapter.notifyDataSetChanged();
                            }

                            @Override
                            public void onError(String Error) {

                            }
                        });
            }

            @Override
            public void refuseBack() {

            }
        });

    }

    /**
     * 修改商品状态
     * @param bean
     * @param statics
     */
    public void changeProductStaticClick(ProductListBean bean,String statics)
    {

        if (statics.equals("3"))
        {
            showCommTextDialog(new RefuseDialogBean("是否则商品状态变为【已上架】", "确认", "取消", "提示"), new CommTextDialog.onAcceptCallBack() {
                @Override
                public void acceptBack() {
                    changeProductStatic(bean,statics);
                }

                @Override
                public void refuseBack() {

                }
            });
        }else {
            changeProductStatic(bean,statics);
        }


    }

    public void changeProductStatic(ProductListBean bean,String statics)
    {
        model.putProductStatic(bean.getBusinessId(),statics).compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(ProductManagerViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<Integer>() {

                    @Override
                    public void onSuccess(Integer resultBean) {
                        listAdapter.mList.remove(bean);
                        listAdapter.notifyDataSetChanged();
                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }





}
