package com.xx.merchanthbh.ui.recruitment;


import static me.goldze.mvvmhabit.utils.Utils.getContext;

import android.os.Bundle;

import androidx.lifecycle.Observer;

import com.google.android.material.tabs.TabLayout;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.RecruitmentRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.JobInformationBean;
import com.xx.merchanthbh.databinding.ActivityRecruitmentListBinding;
import com.xx.merchanthbh.fragment.adapter.JobInformationAdapter;
import com.xx.merchanthbh.ui.huanbohai.HbhBannerAdapter;
import com.youth.banner.indicator.CircleIndicator;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class RecruitmentActivity extends BaseActivity<ActivityRecruitmentListBinding, RecruitmentViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_recruitment_list;
    }

    @Override
    public int initVariableId() {
        return BR.recruitmentViewModel;
    }
    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        /*首页-招聘信息列表*/
        //获取适配器上下文
        JobInformationAdapter jobInformationAdapter = new JobInformationAdapter(getContext());
        //把adapterset进去
        binding.rvZpmsgList.setAdapter(jobInformationAdapter);
        viewModel.JobInformationList.observe(this, new Observer<List<JobInformationBean>>() {
            @Override
            public void onChanged(List<JobInformationBean> jobInformationBeanList) {
                jobInformationAdapter.mList = jobInformationBeanList;
                jobInformationAdapter.notifyDataSetChanged();
            }
        });
        viewModel.getJobsList();

        //调用轮播图广告位接口
        viewModel.getADList();
        // 轮播图 广告遍历
        binding.bannerHuanbohai.addBannerLifecycleObserver(this).setIndicator(new CircleIndicator(getContext()));
        viewModel.AdvertisingList.observe(this, new Observer<List<AdvertisingBean>>() {
            @Override
            public void onChanged(List<AdvertisingBean> advertisingBeans) {
                HbhBannerAdapter bannerAdapter = new HbhBannerAdapter(getContext(), advertisingBeans);
                binding.bannerHuanbohai.setAdapter(bannerAdapter);
            }
        });
        /*切换状态Tab*/
        binding.tabs.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            /*招聘类型 1-内部招聘 2-商户招聘*/
            public void onTabSelected(TabLayout.Tab tab) {
                jobInformationAdapter.mList.clear();
                switch (tab.getPosition()) {
                    case 0:
                        viewModel.recruitmentType = "1";
                        viewModel.getJobsList();
                        break;
                    case 1:
                        viewModel.recruitmentType = "2";
                        viewModel.getJobsList();
                        break;
                }
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });


    }
    @Override
    public RecruitmentViewModel initViewModel() {
        RecruitmentRequest lm = new RecruitmentRequest();
        return new RecruitmentViewModel(getApplication(), lm);
    }
}
