package com.xx.merchanthbh.ui.recruitment;


import android.app.Application;

import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.data.http.requst.RecruitmentRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.JobInformationBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.annotations.NonNull;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class RecruitmentViewModel extends BaseViewModel<RecruitmentRequest> {
    //    创建轮播图广告位实体对象
    public MutableLiveData<List<AdvertisingBean>> AdvertisingList = new MutableLiveData<>(new ArrayList<>());

    //    创建招聘信息实体对象
    public MutableLiveData<List<JobInformationBean>> JobInformationList = new MutableLiveData<>(new ArrayList<>());

    /*招聘类型 1-内部招聘 2-商户招聘*/
    public String recruitmentType = "1";

    public RecruitmentViewModel(@NonNull Application application) {
        super(application);
    }

    public RecruitmentViewModel(@NonNull Application application, RecruitmentRequest model) {
        super(application, model);
    }

    //调用轮播图列表的接口信息
    public void getADList() {
        model.getAdList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(RecruitmentViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AdvertisingBean>>() {
                    @Override
                    public void onSuccess(List<AdvertisingBean> resultBean) {
                        AdvertisingList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    //调用招聘列表的接口信息
    public void getJobsList() {
        model.getJobInformationList(recruitmentType)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(RecruitmentViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<JobInformationBean>() {
                    @Override
                    public void onSuccess(List<JobInformationBean> resultBean) {
                        JobInformationList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }


                });
    }

}
