package com.xx.merchanthbh.ui.share;

import android.app.Application;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;

import com.xx.merchanthbh.app.ListBaseViewModel;
import com.xx.merchanthbh.data.http.requst.ShareRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.AssistantInformationBean;
import com.xx.merchanthbh.data.http.respons.ShareTotalBean;
import com.xx.merchanthbh.dialog.ShareFiltrateDialog;
import com.xx.merchanthbh.ui.assistant.AssistantManagementViewModel;
import com.xx.merchanthbh.ui.recruitment.RecruitmentViewModel;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class ShareViewModel extends BaseViewModel<ShareRequest> {

    public ShareTotalAdapter adapter;

   public List<AssistantInformationBean> personList= new ArrayList();

    public List<AssistantInformationBean> personSelectList= new ArrayList();

    public ShareViewModel(@NonNull Application application) {
        super(application);
    }

    public ShareViewModel(@NonNull Application application, ShareRequest model) {
        super(application, model);
    }

    public void getShareTotalList(String activity)
    {
         List<String> names= new ArrayList();

         for (AssistantInformationBean bean:personSelectList)
         {
             names.add(bean.getShopAssistantName());
         }

        model.getShareTotalList(activity,names).compose(RxUtils.schedulersTransformer()) //线程调度
            .doOnSubscribe(ShareViewModel.this)
            .doOnSubscribe(new Consumer<Disposable>() {
                @Override
                public void accept(Disposable disposable) throws Exception {
                }
            }).subscribe(new ApiDisposableObserver<List<ShareTotalBean>>() {


                    @Override
                    public void onSuccess(List<ShareTotalBean> resultBean) {
                        adapter.mList=resultBean;
                        adapter.notifyDataSetChanged();
                    }

                    @Override
                    public void onError(String Error) {

                    }

                });
    }


    /**
     * 获取店铺人员
     */
    public void geAssistantList() {
        model.getAssistantList().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ShareViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AssistantInformationBean>>() {
                    @Override
                    public void onSuccess(List<AssistantInformationBean> resultBean) {

                        personList=resultBean;

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }



}
